/* defiles.c - disk file read/write for diskedit.c */
/* lrs - 2/13/89 */

#include <stdio.h>
#include "disks.h"   /* for BYTESPERSECTOR */
#include "devideo.h" /* for error messages */
#include "defiles.h"
/*-----------------------------------------------------------------------*/
void ReadFile (char filename[], void* buf)
  { /* Read a binary data file into the sector buffer */
  FILE* fin;

  if ((fin = fopen(filename,"rb")) == NULL)
    ErrorMessage("File Not Found");
  if (fread(buf, BYTESPERSECTOR, 1, fin) != 1)
    ErrorMessage("Error Reading File");
  if (fclose(fin))
    ErrorMessage("Error Closing File");
  }    /* GetFile */

/*-----------------------------------------------------------------------*/
void WriteFile (char filename[], void* buf)
  { /* Save the sector buffer as a binary file */
  FILE* fout;

  if ((fout = fopen(filename,"wb")) == NULL)
    ErrorMessage("File Creation Error");
  else if (fwrite(buf, BYTESPERSECTOR, 1, fout) != 1)
    ErrorMessage("Error Writing File");
  else if (fclose(fout))
    ErrorMessage("Error Closing File");
  }    /* GetFile */

